--- a/arch/ppc/4xx_io/serial_sicc.c
+++ b/arch/ppc/4xx_io/serial_sicc.c
@@ -1729,7 +1707,7 @@ static struct tty_operations sicc_ops = 
 	.flush_chars = siccuart_flush_chars,
 	.write_room = siccuart_write_room,
 	.chars_in_buffer = siccuart_chars_in_buffer,
-	.flush_buffer  = siccuart_flush_buffer,
+	.flush_buffer = siccuart_flush_buffer,
 	.ioctl = siccuart_ioctl,
 	.throttle = siccuart_throttle,
 	.unthrottle = siccuart_unthrottle,
@@ -1744,36 +1722,37 @@ static struct tty_operations sicc_ops = 
 
 int __init siccuart_init(void)
 {
-    int i;
-    siccnormal_driver = alloc_tty_driver(SERIAL_SICC_NR);
-    if (!siccnormal_driver)
-	return -ENOMEM;
-    printk("IBM Vesta SICC serial port driver V 0.1 by Yudong Yang and Yi Ge / IBM CRL .\n");
-    siccnormal_driver->driver_name = "serial_sicc";
-    siccnormal_driver->owner = THIS_MODULE;
-    siccnormal_driver->name = SERIAL_SICC_NAME;
-    siccnormal_driver->major = SERIAL_SICC_MAJOR;
-    siccnormal_driver->minor_start = SERIAL_SICC_MINOR;
-    siccnormal_driver->type = TTY_DRIVER_TYPE_SERIAL;
-    siccnormal_driver->subtype = SERIAL_TYPE_NORMAL;
-    siccnormal_driver->init_termios = tty_std_termios;
-    siccnormal_driver->init_termios.c_cflag = B9600 | CS8 | CREAD | HUPCL | CLOCAL;
-    siccnormal_driver->flags = TTY_DRIVER_REAL_RAW | TTY_DRIVER_NO_DEVFS;
-    tty_set_operations(siccnormal_driver, &sicc_ops);
-
-    if (tty_register_driver(siccnormal_driver))
-        panic("Couldn't register SICC serial driver\n");
-
-    for (i = 0; i < SERIAL_SICC_NR; i++) {
-        struct SICC_state *state = sicc_state + i;
-        state->line     = i;
-        state->close_delay  = msecs_to_jiffies(500);
-        state->closing_wait = 30 * HZ;
-	spin_lock_init(&state->sicc_lock);
-    }
-
+	int i;
+	siccnormal_driver = alloc_tty_driver(SERIAL_SICC_NR);
+	if (!siccnormal_driver)
+		return -ENOMEM;
+	printk
+	    ("IBM Vesta SICC serial port driver V 0.1 by Yudong Yang and Yi Ge / IBM CRL .\n");
+	siccnormal_driver->driver_name = "serial_sicc";
+	siccnormal_driver->owner = THIS_MODULE;
+	siccnormal_driver->name = SERIAL_SICC_NAME;
+	siccnormal_driver->major = SERIAL_SICC_MAJOR;
+	siccnormal_driver->minor_start = SERIAL_SICC_MINOR;
+	siccnormal_driver->type = TTY_DRIVER_TYPE_SERIAL;
+	siccnormal_driver->subtype = SERIAL_TYPE_NORMAL;
+	siccnormal_driver->init_termios = tty_std_termios;
+	siccnormal_driver->init_termios.c_cflag =
+	    B9600 | CS8 | CREAD | HUPCL | CLOCAL;
+	siccnormal_driver->flags = TTY_DRIVER_REAL_RAW | TTY_DRIVER_NO_DEVFS;
+	tty_set_operations(siccnormal_driver, &sicc_ops);
+
+	if (tty_register_driver(siccnormal_driver))
+		panic("Couldn't register SICC serial driver\n");
+
+	for (i = 0; i < SERIAL_SICC_NR; i++) {
+		struct SICC_state *state = sicc_state + i;
+		state->line = i;
+		state->close_delay = msecs_to_jiffies(500);
+		state->closing_wait = 30 * HZ;
+		spin_lock_init(&state->sicc_lock);
+	}
 
-    return 0;
+	return 0;
 }
 
 __initcall(siccuart_init);
@@ -1790,26 +1769,26 @@ __initcall(siccuart_init);
 #ifdef used_and_not_const_char_pointer
 static int siccuart_console_read(struct console *co, const char *s, u_int count)
 {
-    struct SICC_port *port = &sicc_ports[co->index];
-    unsigned int status;
-    char *w;
-    int c;
-
-    pr_debug("siccuart_console_read() called\n");
-
-    c = 0;
-    w = s;
-    while (c < count) {
-        if(readb(port->uart_base +  BL_SICC_LSR) & _LSR_RBR_FULL) {
-            *w++ = readb(port->uart_base +  BL_SICC_RBR);
-            c++;
-        } else {
-            // nothing more to get, return
-            return c;
-        }
-    }
-    // return the count
-    return c;
+	struct SICC_port *port = &sicc_ports[co->index];
+	unsigned int status;
+	char *w;
+	int c;
+
+	pr_debug("siccuart_console_read() called\n");
+
+	c = 0;
+	w = s;
+	while (c < count) {
+		if (readb(port->uart_base + BL_SICC_LSR) & _LSR_RBR_FULL) {
+			*w++ = readb(port->uart_base + BL_SICC_RBR);
+			c++;
+		} else {
+			// nothing more to get, return
+			return c;
+		}
+	}
+	// return the count
+	return c;
 }
 #endif
 
@@ -1819,36 +1798,40 @@ static int siccuart_console_read(struct 
  *
  *  The console_lock must be held when we get here.
  */
-static void siccuart_console_write(struct console *co, const char *s, u_int count)
+static void siccuart_console_write(struct console *co, const char *s,
+				   u_int count)
 {
-    struct SICC_port *port = &sicc_ports[co->index];
-    unsigned int old_cr;
-    int i;
-
-    /*
-     *  First save the CR then disable the interrupts
-     */
-    old_cr = readb(port->uart_base +  BL_SICC_TxCR);
-    writeb(old_cr & ~_TxCR_DME_MASK, port->uart_base +  BL_SICC_TxCR);
-
-    /*
-     *  Now, do each character
-     */
-    for (i = 0; i < count; i++) {
-        while ((readb(port->uart_base +  BL_SICC_LSR)&_LSR_TX_ALL) != _LSR_TX_ALL);
-        writeb(s[i], port->uart_base +  BL_SICC_TBR);
-        if (s[i] == '\n') {
-            while ((readb(port->uart_base +  BL_SICC_LSR)&_LSR_TX_ALL) != _LSR_TX_ALL);
-            writeb('\r', port->uart_base +  BL_SICC_TBR);
-        }
-    }
-
-    /*
-     *  Finally, wait for transmitter to become empty
-     *  and restore the TCR
-     */
-    while ((readb(port->uart_base +  BL_SICC_LSR)&_LSR_TX_ALL) != _LSR_TX_ALL);
-    writeb(old_cr, port->uart_base +  BL_SICC_TxCR);
+	struct SICC_port *port = &sicc_ports[co->index];
+	unsigned int old_cr;
+	int i;
+
+	/*
+	 *  First save the CR then disable the interrupts
+	 */
+	old_cr = readb(port->uart_base + BL_SICC_TxCR);
+	writeb(old_cr & ~_TxCR_DME_MASK, port->uart_base + BL_SICC_TxCR);
+
+	/*
+	 *  Now, do each character
+	 */
+	for (i = 0; i < count; i++) {
+		while ((readb(port->uart_base + BL_SICC_LSR) & _LSR_TX_ALL) !=
+		       _LSR_TX_ALL) ;
+		writeb(s[i], port->uart_base + BL_SICC_TBR);
+		if (s[i] == '\n') {
+			while ((readb(port->uart_base + BL_SICC_LSR) &
+				_LSR_TX_ALL) != _LSR_TX_ALL) ;
+			writeb('\r', port->uart_base + BL_SICC_TBR);
+		}
+	}
+
+	/*
+	 *  Finally, wait for transmitter to become empty
+	 *  and restore the TCR
+	 */
+	while ((readb(port->uart_base + BL_SICC_LSR) & _LSR_TX_ALL) !=
+	       _LSR_TX_ALL) ;
+	writeb(old_cr, port->uart_base + BL_SICC_TxCR);
 }
 
 /*
@@ -1856,12 +1839,12 @@ static void siccuart_console_write(struc
  */
 static int siccuart_console_wait_key(struct console *co)
 {
-    struct SICC_port *port = &sicc_ports[co->index];
-    int c;
+	struct SICC_port *port = &sicc_ports[co->index];
+	int c;
 
-    while(!(readb(port->uart_base +  BL_SICC_LSR) & _LSR_RBR_FULL));
-    c = readb(port->uart_base +  BL_SICC_RBR);
-    return c;
+	while (!(readb(port->uart_base + BL_SICC_LSR) & _LSR_RBR_FULL)) ;
+	c = readb(port->uart_base + BL_SICC_RBR);
+	return c;
 }
 
 static struct tty_driver *siccuart_console_device(struct console *c, int *index)
@@ -1872,135 +1855,164 @@ static struct tty_driver *siccuart_conso
 
 static int __init siccuart_console_setup(struct console *co, char *options)
 {
-    struct SICC_port *port;
-    int baud = 9600;
-    int bits = 8;
-    int parity = 'n';
-    u_int cflag = CREAD | HUPCL | CLOCAL;
-    u_int lcr_h, quot;
-
-
-    if (co->index >= SERIAL_SICC_NR)
-        co->index = 0;
-
-    port = &sicc_ports[co->index];
-
-    if (port->uart_base == 0)
-	port->uart_base = (int)ioremap(port->uart_base_phys, PAGE_SIZE);
-
-    if (options) {
-        char *s = options;
-        baud = simple_strtoul(s, NULL, 10);
-        while (*s >= '0' && *s <= '9')
-            s++;
-        if (*s) parity = *s++;
-        if (*s) bits = *s - '0';
-    }
-
-    /*
-     *    Now construct a cflag setting.
-     */
-    switch (baud) {
-    case 1200:  cflag |= B1200;         break;
-    case 2400:  cflag |= B2400;         break;
-    case 4800:  cflag |= B4800;         break;
-    default:    cflag |= B9600;   baud = 9600;  break;
-    case 19200: cflag |= B19200;        break;
-    case 38400: cflag |= B38400;        break;
-    case 57600: cflag |= B57600;        break;
-    case 115200:    cflag |= B115200;       break;
-    }
-    switch (bits) {
-    case 7:   cflag |= CS7; lcr_h = _LCR_PE_DISABLE | _LCR_DB_7_BITS | _LCR_SB_1_BIT;   break;
-    default:  cflag |= CS8; lcr_h = _LCR_PE_DISABLE | _LCR_DB_8_BITS | _LCR_SB_1_BIT;   break;
-    }
-    switch (parity) {
-    case 'o':
-    case 'O': cflag |= PARODD; lcr_h |= _LCR_PTY_ODD;   break;
-    case 'e':
-    case 'E': cflag |= PARENB; lcr_h |= _LCR_PE_ENABLE |  _LCR_PTY_ODD; break;
-    }
-
-    co->cflag = cflag;
-
-
-       {
-           // a copy of is inserted here ppc403SetBaud(com_port, (int)9600);
-           unsigned long divisor, clockSource, temp;
-           unsigned int rate = baud;
-
-          /* Ensure CICCR[7] is 0 to select Internal Baud Clock */
-          powerpcMtcic_cr((unsigned long)(powerpcMfcic_cr() & 0xFEFFFFFF));
-
-          /* Determine Internal Baud Clock Frequency */
-          /* powerpcMfclkgpcr() reads DCR 0x120 - the*/
-          /* SCCR (Serial Clock Control Register) on Vesta */
-          temp = powerpcMfclkgpcr();
-
-          if(temp & 0x00000080) {
-              clockSource = 324000000;
-          }
-          else {
-              clockSource = 216000000;
-          }
-          clockSource = clockSource/(unsigned long)((temp&0x00FC0000)>>18);
-          divisor = clockSource/(16*rate) - 1;
-          /* divisor has only 12 bits of resolution */
-          if(divisor>0x00000FFF){
-               divisor=0x00000FFF;
-          }
-
-          quot = divisor;
-       }
-
-    writeb((quot & 0x00000F00)>>8, port->uart_base + BL_SICC_BRDH );
-    writeb( quot & 0x00000FF,      port->uart_base   + BL_SICC_BRDL );
-
-    /* Set CTL2 reg to use external clock (ExtClk) and enable FIFOs. */
-    /* For now, do NOT use FIFOs since 403 UART did not have this    */
-    /* capability and this driver was inherited from 403UART.        */
-    writeb(_CTL2_EXTERN, port->uart_base  + BL_SICC_CTL2);
-
-    writeb(lcr_h, port->uart_base + BL_SICC_LCR);
-    writeb(_RCR_ER_ENABLE | _RCR_PME_HARD, port->uart_base + BL_SICC_RCR);
-    writeb( _TxCR_ET_ENABLE , port->uart_base + BL_SICC_TxCR);
-
-    // writeb(, info->port->uart_base + BL_SICC_RCR );
-    /*
-     * Transmitter Command Register: Transmitter enabled & DMA + TBR interrupt
-     * + Transmitter Empty interrupt + Transmitter error interrupt disabled &
-     * Stop mode when CTS active enabled & Transmit Break + Pattern Generation
-     * mode disabled.
-     */
-
-    writeb( 0x00, port->uart_base + BL_SICC_IrCR );  // disable IrDA
-
-    readb(port->uart_base + BL_SICC_RBR);
-
-    writeb(0xf8, port->uart_base + BL_SICC_LSR);   /* reset bits 0-4 of LSR */
-
-    /* we will enable the port as we need it */
-
-    return 0;
-}
-
-static struct console siccuart_cons =
-{
-    .name =     SERIAL_SICC_NAME,
-    .write =    siccuart_console_write,
+	struct SICC_port *port;
+	int baud = 9600;
+	int bits = 8;
+	int parity = 'n';
+	u_int cflag = CREAD | HUPCL | CLOCAL;
+	u_int lcr_h, quot;
+
+	if (co->index >= SERIAL_SICC_NR)
+		co->index = 0;
+
+	port = &sicc_ports[co->index];
+
+	if (port->uart_base == 0)
+		port->uart_base = (int)ioremap(port->uart_base_phys, PAGE_SIZE);
+
+	if (options) {
+		char *s = options;
+		baud = simple_strtoul(s, NULL, 10);
+		while (*s >= '0' && *s <= '9')
+			s++;
+		if (*s)
+			parity = *s++;
+		if (*s)
+			bits = *s - '0';
+	}
+
+	/*
+	 *    Now construct a cflag setting.
+	 */
+	switch (baud) {
+	case 1200:
+		cflag |= B1200;
+		break;
+	case 2400:
+		cflag |= B2400;
+		break;
+	case 4800:
+		cflag |= B4800;
+		break;
+	default:
+		cflag |= B9600;
+		baud = 9600;
+		break;
+	case 19200:
+		cflag |= B19200;
+		break;
+	case 38400:
+		cflag |= B38400;
+		break;
+	case 57600:
+		cflag |= B57600;
+		break;
+	case 115200:
+		cflag |= B115200;
+		break;
+	}
+	switch (bits) {
+	case 7:
+		cflag |= CS7;
+		lcr_h = _LCR_PE_DISABLE | _LCR_DB_7_BITS | _LCR_SB_1_BIT;
+		break;
+	default:
+		cflag |= CS8;
+		lcr_h = _LCR_PE_DISABLE | _LCR_DB_8_BITS | _LCR_SB_1_BIT;
+		break;
+	}
+	switch (parity) {
+	case 'o':
+	case 'O':
+		cflag |= PARODD;
+		lcr_h |= _LCR_PTY_ODD;
+		break;
+	case 'e':
+	case 'E':
+		cflag |= PARENB;
+		lcr_h |= _LCR_PE_ENABLE | _LCR_PTY_ODD;
+		break;
+	}
+
+	co->cflag = cflag;
+
+	{
+		// a copy of is inserted here ppc403SetBaud(com_port, (int)9600);
+		unsigned long divisor, clockSource, temp;
+		unsigned int rate = baud;
+
+		/* Ensure CICCR[7] is 0 to select Internal Baud Clock */
+		powerpcMtcic_cr((unsigned long)(powerpcMfcic_cr() &
+						0xFEFFFFFF));
+
+		/* Determine Internal Baud Clock Frequency */
+		/* powerpcMfclkgpcr() reads DCR 0x120 - the */
+		/* SCCR (Serial Clock Control Register) on Vesta */
+		temp = powerpcMfclkgpcr();
+
+		if (temp & 0x00000080) {
+			clockSource = 324000000;
+		} else {
+			clockSource = 216000000;
+		}
+		clockSource =
+		    clockSource / (unsigned long)((temp & 0x00FC0000) >> 18);
+		divisor = clockSource / (16 * rate) - 1;
+		/* divisor has only 12 bits of resolution */
+		if (divisor > 0x00000FFF) {
+			divisor = 0x00000FFF;
+		}
+
+		quot = divisor;
+	}
+
+	writeb((quot & 0x00000F00) >> 8, port->uart_base + BL_SICC_BRDH);
+	writeb(quot & 0x00000FF, port->uart_base + BL_SICC_BRDL);
+
+	/* Set CTL2 reg to use external clock (ExtClk) and enable FIFOs. */
+	/* For now, do NOT use FIFOs since 403 UART did not have this    */
+	/* capability and this driver was inherited from 403UART.        */
+	writeb(_CTL2_EXTERN, port->uart_base + BL_SICC_CTL2);
+
+	writeb(lcr_h, port->uart_base + BL_SICC_LCR);
+	writeb(_RCR_ER_ENABLE | _RCR_PME_HARD, port->uart_base + BL_SICC_RCR);
+	writeb(_TxCR_ET_ENABLE, port->uart_base + BL_SICC_TxCR);
+
+	// writeb(, info->port->uart_base + BL_SICC_RCR );
+	/*
+	 * Transmitter Command Register: Transmitter enabled & DMA + TBR interrupt
+	 * + Transmitter Empty interrupt + Transmitter error interrupt disabled &
+	 * Stop mode when CTS active enabled & Transmit Break + Pattern Generation
+	 * mode disabled.
+	 */
+
+	writeb(0x00, port->uart_base + BL_SICC_IrCR);	// disable IrDA
+
+	readb(port->uart_base + BL_SICC_RBR);
+
+	writeb(0xf8, port->uart_base + BL_SICC_LSR);	/* reset bits 0-4 of LSR */
+
+	/* we will enable the port as we need it */
+
+	return 0;
+}
+
+static struct console siccuart_cons = {
+	.name = SERIAL_SICC_NAME,
+	.write = siccuart_console_write,
 #ifdef used_and_not_const_char_pointer
-    .read =     siccuart_console_read,
+	.read = siccuart_console_read,
 #endif
-    .device =   siccuart_console_device,
-    .wait_key = siccuart_console_wait_key,
-    .setup =    siccuart_console_setup,
-    .flags =    CON_PRINTBUFFER,
-    .index =    -1,
+	.device = siccuart_console_device,
+	.wait_key = siccuart_console_wait_key,
+	.setup = siccuart_console_setup,
+	.flags = CON_PRINTBUFFER,
+	.index = -1,
 };
 
 void __init sicc_console_init(void)
 {
-    register_console(&siccuart_cons);
+	register_console(&siccuart_cons);
 }
 
-#endif /* CONFIG_SERIAL_SICC_CONSOLE */
+#endif				/* CONFIG_SERIAL_SICC_CONSOLE */
--- a/arch/ppc/8260_io/fcc_enet.c
+++ b/arch/ppc/8260_io/fcc_enet.c
@@ -1305,11 +1305,9 @@ static void mii_parse_dm9161_scsr(uint m
 
 static void mii_dm9161_wait(uint mii_reg, struct net_device *dev)
 {
-	int timeout = HZ;
-
 	/* Davicom takes a bit to come up after a reset,
 	 * so wait here for a bit */
-	schedule_timeout_uninterruptible(timeout);
+	ssleep(1);
 }
 
 static phy_info_t phy_info_dm9161 = {
--- a/arch/ppc/syslib/Makefile
+++ b/arch/ppc/syslib/Makefile
@@ -37,7 +37,6 @@ endif
 endif
 obj-$(CONFIG_8xx)		+= m8xx_setup.o ppc8xx_pic.o $(wdt-mpc8xx-y) \
 				   ppc_sys.o mpc8xx_devices.o mpc8xx_sys.o
-obj-$(CONFIG_PCI_QSPAN)		+= qspan_pci.o
 obj-$(CONFIG_PPC_PREP)		+= open_pic.o todc_time.o
 obj-$(CONFIG_BAMBOO)		+= pci_auto.o todc_time.o
 obj-$(CONFIG_CPCI690)		+= todc_time.o pci_auto.o
--- a/arch/sh/drivers/dma/dma-api.c
+++ b/arch/sh/drivers/dma/dma-api.c
@@ -288,10 +288,13 @@ void unregister_dmac(struct dma_info *in
 
 static int __init dma_api_init(void)
 {
+	struct proc_dir_entry *ent;
 	printk("DMA: Registering DMA API.\n");
 
 #ifdef CONFIG_PROC_FS
-	create_proc_read_entry("dma", 0, 0, dma_read_proc, 0);
+	ent = create_proc_read_entry("dma", 0, 0, dma_read_proc, 0);
+	if (!ent)
+		printk(KERN_WARNING "dma-api.c: unable to create /proc entry\n");
 #endif
 
 	return 0;
--- a/arch/sh/kernel/cpu/sh4/sq.c
+++ b/arch/sh/kernel/cpu/sh4/sq.c
@@ -423,10 +423,14 @@ static struct miscdevice sq_dev = {
 
 static int __init sq_api_init(void)
 {
+	struct proc_dir_entry *ent;
 	printk(KERN_NOTICE "sq: Registering store queue API.\n");
 
 #ifdef CONFIG_PROC_FS
-	create_proc_read_entry("sq_mapping", 0, 0, sq_mapping_read_proc, 0);
+	ent = create_proc_read_entry("sq_mapping", 0, 0, 
+		sq_mapping_read_proc, 0);
+	if (!ent)
+		printk(KERN_WARNING "sq: unable to create /proc entry\n");
 #endif
 
 	return misc_register(&sq_dev);
--- a/arch/sh64/kernel/process.c
+++ b/arch/sh64/kernel/process.c
@@ -927,7 +927,11 @@ asids_proc_info(char *buf, char **start,
 
 static int __init register_proc_asids(void)
 {
-  create_proc_read_entry("asids", 0, NULL, asids_proc_info, NULL);
+	struct proc_dir_entry *ent;
+	ent = create_proc_read_entry("asids", 0, NULL, asids_proc_info, NULL);
+	if (!ent)
+		printk(KERN_WARNING 
+			"process.c: unable to create asids /proc entry\n");
   return 0;
 }
 
--- a/arch/sh64/mm/fault.c
+++ b/arch/sh64/mm/fault.c
@@ -592,8 +592,11 @@ tlb_proc_info(char *buf, char **start, o
 
 static int __init register_proc_tlb(void)
 {
-  create_proc_read_entry("tlb", 0, NULL, tlb_proc_info, NULL);
-  return 0;
+	struct proc_dir_entry *ent;
+	ent = create_proc_read_entry("tlb", 0, NULL, tlb_proc_info, NULL);
+	if (!ent)
+		printk(KERN_WARNING "fault.c: unable to create tlb /proc entry\n");
+	return 0;
 }
 
 __initcall(register_proc_tlb);
--- a/arch/sh64/mm/ioremap.c
+++ b/arch/sh64/mm/ioremap.c
@@ -459,7 +459,11 @@ ioremap_proc_info(char *buf, char **star
 static int __init register_proc_onchip(void)
 {
 #ifdef CONFIG_PROC_FS
-	create_proc_read_entry("io_map",0,0, ioremap_proc_info, &shmedia_iomap);
+	struct proc_dir_entry *ent;
+	ent = create_proc_read_entry("io_map",0,0, 
+		ioremap_proc_info, &shmedia_iomap);
+	if (!ent)
+		printk(KERN_WARNING "ioremap.c: unable to create /proc entry\n");
 #endif
 	return 0;
 }
--- a/arch/sparc/kernel/ioport.c
+++ b/arch/sparc/kernel/ioport.c
@@ -255,9 +255,8 @@ void *sbus_alloc_consistent(struct sbus_
 	if ((va = __get_free_pages(GFP_KERNEL|__GFP_COMP, order)) == 0)
 		goto err_nopages;
 
-	if ((res = kmalloc(sizeof(struct resource), GFP_KERNEL)) == NULL)
+	if ((res = kzalloc(sizeof(struct resource), GFP_KERNEL)) == NULL)
 		goto err_nomem;
-	memset((char*)res, 0, sizeof(struct resource));
 
 	if (allocate_resource(&_sparc_dvma, res, len_total,
 	    _sparc_dvma.start, _sparc_dvma.end, PAGE_SIZE, NULL, NULL) != 0) {
@@ -437,12 +436,11 @@ void *pci_alloc_consistent(struct pci_de
 		return NULL;
 	}
 
-	if ((res = kmalloc(sizeof(struct resource), GFP_KERNEL)) == NULL) {
+	if ((res = kzalloc(sizeof(struct resource), GFP_KERNEL)) == NULL) {
 		free_pages(va, order);
 		printk("pci_alloc_consistent: no core\n");
 		return NULL;
 	}
-	memset((char*)res, 0, sizeof(struct resource));
 
 	if (allocate_resource(&_sparc_dvma, res, len_total,
 	    _sparc_dvma.start, _sparc_dvma.end, PAGE_SIZE, NULL, NULL) != 0) {
@@ -715,7 +713,16 @@ _sparc_find_resource(struct resource *ro
 void register_proc_sparc_ioport(void)
 {
 #ifdef CONFIG_PROC_FS
-	create_proc_read_entry("io_map",0,NULL,_sparc_io_get_info,&sparc_iomap);
-	create_proc_read_entry("dvma_map",0,NULL,_sparc_io_get_info,&_sparc_dvma);
+	struct proc_dir_entry *ent;
+	ent = create_proc_read_entry("io_map",0,NULL,
+		_sparc_io_get_info,&sparc_iomap);
+	if (!ent)
+		printk(KERN_WARNING 
+			"ioport.c: unable to create io_map /proc entry\n");
+	ent = create_proc_read_entry("dvma_map",0,NULL,
+		_sparc_io_get_info,&_sparc_dvma);
+	if (!ent)
+		printk(KERN_WARNING 
+			"ioport.c: unable to create dvma_map /proc entry\n");
 #endif
 }
--- a/arch/sparc/kernel/sun4d_irq.c
+++ b/arch/sparc/kernel/sun4d_irq.c
@@ -542,8 +542,7 @@ void __init sun4d_init_sbi_irq(void)
 	nsbi = 0;
 	for_each_sbus(sbus)
 		nsbi++;
-	sbus_actions = (struct sbus_action *)kmalloc (nsbi * 8 * 4 * sizeof(struct sbus_action), GFP_ATOMIC);
-	memset (sbus_actions, 0, (nsbi * 8 * 4 * sizeof(struct sbus_action)));
+	sbus_actions = kzalloc(nsbi * 8 * 4 * sizeof(struct sbus_action), GFP_ATOMIC);
 	for_each_sbus(sbus) {
 #ifdef CONFIG_SMP	
 		extern unsigned char boot_cpu_id;
--- a/arch/sparc/mm/io-unit.c
+++ b/arch/sparc/mm/io-unit.c
@@ -42,9 +42,8 @@ iounit_init(int sbi_node, int io_node, s
 	struct linux_prom_registers iommu_promregs[PROMREG_MAX];
 	struct resource r;
 
-	iounit = kmalloc(sizeof(struct iounit_struct), GFP_ATOMIC);
+	iounit = kzalloc(sizeof(struct iounit_struct), GFP_ATOMIC);
 
-	memset(iounit, 0, sizeof(*iounit));
 	iounit->limit[0] = IOUNIT_BMAP1_START;
 	iounit->limit[1] = IOUNIT_BMAP2_START;
 	iounit->limit[2] = IOUNIT_BMAPM_START;
--- a/arch/x86_64/kernel/io_apic.c
+++ b/arch/x86_64/kernel/io_apic.c
@@ -2006,12 +2006,11 @@ static int __init ioapic_init_sysfs(void
 	for (i = 0; i < nr_ioapics; i++ ) {
 		size = sizeof(struct sys_device) + nr_ioapic_registers[i]
 			* sizeof(struct IO_APIC_route_entry);
-		mp_ioapic_data[i] = kmalloc(size, GFP_KERNEL);
+		mp_ioapic_data[i] = kzalloc(size, GFP_KERNEL);
 		if (!mp_ioapic_data[i]) {
 			printk(KERN_ERR "Can't suspend/resume IOAPIC %d\n", i);
 			continue;
 		}
-		memset(mp_ioapic_data[i], 0, size);
 		dev = &mp_ioapic_data[i]->dev;
 		dev->id = i;
 		dev->cls = &ioapic_sysdev_class;
--- a/arch/x86_64/kernel/mce_amd.c
+++ b/arch/x86_64/kernel/mce_amd.c
@@ -342,12 +342,11 @@ static __cpuinit int threshold_create_ba
 	}
 #endif
 
-	b = kmalloc(sizeof(struct threshold_bank), GFP_KERNEL);
+	b = kzalloc(sizeof(struct threshold_bank), GFP_KERNEL);
 	if (!b) {
 		err = -ENOMEM;
 		goto out;
 	}
-	memset(b, 0, sizeof(struct threshold_bank));
 
 	b->cpu = cpu;
 	b->bank = bank;
--- a/arch/x86_64/Makefile
+++ b/arch/x86_64/Makefile
@@ -44,7 +44,7 @@ CFLAGS += -Wno-sign-compare
 ifneq ($(CONFIG_UNWIND_INFO),y)
 CFLAGS += -fno-asynchronous-unwind-tables
 endif
-ifneq ($(CONFIG_DEBUG_INFO),y)
+ifndef CONFIG_DEBUG_INFO
 # -fweb shrinks the kernel a bit, but the difference is very small
 # it also messes up debugging, so don't use it for now.
 #CFLAGS += $(call cc-option,-fweb)
--- a/Documentation/connector/cn_test.c
+++ b/Documentation/connector/cn_test.c
@@ -124,10 +124,8 @@ static void cn_test_timer_func(unsigned 
 	struct cn_msg *m;
 	char data[32];
 
-	m = kmalloc(sizeof(*m) + sizeof(data), GFP_ATOMIC);
+	m = kzalloc(sizeof(*m) + sizeof(data), GFP_ATOMIC);
 	if (m) {
-		memset(m, 0, sizeof(*m) + sizeof(data));
-
 		memcpy(&m->id, &cn_test_id, sizeof(m->id));
 		m->seq = cn_test_timer_counter;
 		m->len = sizeof(data);
--- a/Documentation/filesystems/configfs/configfs_example.c
+++ b/Documentation/filesystems/configfs/configfs_example.c
@@ -268,12 +268,10 @@ static struct config_item *simple_childr
 {
 	struct simple_child *simple_child;
 
-	simple_child = kmalloc(sizeof(struct simple_child), GFP_KERNEL);
+	simple_child = kzalloc(sizeof(struct simple_child), GFP_KERNEL);
 	if (!simple_child)
 		return NULL;
 
-	memset(simple_child, 0, sizeof(struct simple_child));
-
 	config_item_init_type_name(&simple_child->item, name,
 				   &simple_child_type);
 
@@ -353,13 +351,11 @@ static struct config_group *group_childr
 {
 	struct simple_children *simple_children;
 
-	simple_children = kmalloc(sizeof(struct simple_children),
+	simple_children = kzalloc(sizeof(struct simple_children),
 				  GFP_KERNEL);
 	if (!simple_children)
 		return NULL;
 
-	memset(simple_children, 0, sizeof(struct simple_children));
-
 	config_group_init_type_name(&simple_children->group, name,
 				    &simple_children_type);
 
--- a/Documentation/sound/alsa/DocBook/writing-an-alsa-driver.tmpl
+++ b/Documentation/sound/alsa/DocBook/writing-an-alsa-driver.tmpl
@@ -1123,8 +1123,8 @@
           if ((err = pci_enable_device(pci)) < 0)
                   return err;
           /* check PCI availability (28bit DMA) */
-          if (pci_set_dma_mask(pci, 0x0fffffff) < 0 ||
-              pci_set_consistent_dma_mask(pci, 0x0fffffff) < 0) {
+          if (pci_set_dma_mask(pci, DMA_28BIT_MASK) < 0 ||
+              pci_set_consistent_dma_mask(pci, DMA_28BIT_MASK) < 0) {
                   printk(KERN_ERR "error to set 28bit mask DMA\n");
                   pci_disable_device(pci);
                   return -ENXIO;
@@ -1216,7 +1216,7 @@
         The allocation of PCI resources is done in the
       <function>probe()</function> function, and usually an extra
       <function>xxx_create()</function> function is written for this
-      purpose. 
+      purpose.
       </para>
 
       <para>
@@ -1225,7 +1225,7 @@
       allocating resources. Also, you need to set the proper PCI DMA
       mask to limit the accessed i/o range. In some cases, you might
       need to call <function>pci_set_master()</function> function,
-      too. 
+      too.
       </para>
 
       <para>
@@ -1236,8 +1236,8 @@
 <![CDATA[
   if ((err = pci_enable_device(pci)) < 0)
           return err;
-  if (pci_set_dma_mask(pci, 0x0fffffff) < 0 ||
-      pci_set_consistent_dma_mask(pci, 0x0fffffff) < 0) {
+  if (pci_set_dma_mask(pci, DMA_28BIT_MASK) < 0 ||
+      pci_set_consistent_dma_mask(pci, DMA_28BIT_MASK) < 0) {
           printk(KERN_ERR "error to set 28bit mask DMA\n");
           pci_disable_device(pci);
           return -ENXIO;
@@ -1256,13 +1256,13 @@
       functions. Unlike ALSA ver.0.5.x., there are no helpers for
       that. And these resources must be released in the destructor
       function (see below). Also, on ALSA 0.9.x, you don't need to
-      allocate (pseudo-)DMA for PCI like ALSA 0.5.x. 
+      allocate (pseudo-)DMA for PCI like ALSA 0.5.x.
       </para>
 
       <para>
         Now assume that this PCI device has an I/O port with 8 bytes
         and an interrupt. Then struct <structname>mychip</structname> will have the
-        following fields: 
+        following fields:
 
         <informalexample>
           <programlisting>
